---
docType: content
title: About HTML-validate
nav: about
---

# About HTML-validate

HTML-validate was created by David Sveningsson in early 2016 with a few goals in mind:

- Enterprise and privacy friendly: no data should leave the machine.
- Pluggable and extendable: must be easy to extend with own domain-specific
  functionality and rules.
- Strict and non-forgiving: should never try to autocorrect or guess anything.
- First-class support for views, components and templates, including when using
  javascript frameworks.

## Talks

- [HTML5 validation with HTML-validate](https://video.fosdem.org/2021/D.javascript/html5_validation.webm) at FOSDEM 2021
- [Accessibility testing with HTML-Validate](https://fosdem.org/2022/schedule/event/accessibility_testing_with_html_validate/) at FOSDEM 2022

## Contact

If you found a bug or want to suggest a new feature/enhancement please [file a
new issue](https://gitlab.com/html-validate/html-validate/issues/new).

For questions about the project feel free to contact the project owner at
[contact@html-validate.org](mailto:contact@html-validate.org).

Support is also available at IRC libera.chat [#html-validate](https://kiwiirc.com/client/irc.libera.chat/#html-validate).
